<?php

  class sml_env_config extends sml_env
  {

    var $config_file;
    var $PATHES;
    var $PARAMS;
    var $CONFIG;
    var $bdd;

    function load_config($config_file)
    { if($config_file && file_exists($config_file))
      { $this->config_file = $config_file;
        require $config_file;
        $this->PATHES = $PATHES;
        $this->bdd = $bdd;
        $this->CONFIG = isset($CONFIG) ? $CONFIG : array();
        $this->PATHES["app"] .= $this->PATHES["app"] && substr($this->PATHES["app"], -1) != "/" ? "/" : "";
        $this->PATHES["current_app"] .= $this->PATHES["current_app"] && substr($this->PATHES["current_app"], -1) != "/" ? "/" : "";
        $this->PATHES["core_app"] .= $this->PATHES["core_app"] && substr($this->PATHES["core_app"], -1) != "/" ? "/" : "";
        $this->PATHES["libs"] .= $this->PATHES["libs"] && substr($this->PATHES["libs"], -1) != "/" ? "/" : "";
        if($app_config_file = ($this->app_file_exists("config.xml") ? $this->app_file("config.xml") : ""))
        { $xml_parser = new sxml();
          $xml_parser->parse(file_get_contents($app_config_file));
          $app_config = $xml_parser->data["config"][0];
          foreach($this->PATHES as $path_name => $path_value)
          { if($path_value && substr($path_value, -1) != "/") $this->PATHES[$path_name] .= "/";
          }
          $this->PARAMS = array();
          foreach($app_config["subs"]["params"][0]["subs"] as $param_key => $param_elt)
          { $this->PARAMS[$param_key] = $param_elt[0]["data"];
          }
          foreach($app_config["subs"]["config"][0]["subs"] as $config_key => $config_elt)
          { $this->CONFIG[$config_key] = $config_elt[0]["data"];
          }
          $this->init_additional_get_params();
          $this->bdd["table_prefix"] = array();
          $this->add_table_prefix
          ( array
            ( $app_config["subs"]["bdd"][0]["subs"]["table_prefix_code"][0]["data"] => $bdd["table_prefix"]
            )
          );
        }
        else $this->erreur("impossible de trouver le fichier de configuration pour l'application", true);
      }
      else $this->erreur("impossible de trouver le fichier de configuration pour l'installation", true);
    }

    function get_config_file() { return $this->config_file; }
    function get_PATHES() { return $this->PATHES; }
    function get_CONFIG() { return $this->CONFIG; }
    function get_PARAMS() { return $this->PARAMS; }
    function get_bdd() { return $this->bdd; }
    function path($name) { return $this->PATHES[$name]; }
    function param($name) { return $this->PARAMS[$name]; }
    function config($name) { return $this->CONFIG[$name]; }
    function bdd($name) { return $this->bdd[$name]; }

    function set_bdd($key, $value) { $this->bdd[$key] = $value; }

    function set_config($config)
    { if(is_array($config))
      { foreach($config as $key => $value) $this->CONFIG[$key] = $value;
        return true;
      }
      return false;
    }

    function add_table_prefix($table_prefix)
    { if(is_array($table_prefix))
      { foreach($table_prefix as $prefix_code => $prefix) $this->bdd["table_prefix"][$prefix_code] = $prefix;
        return true;
      }
      return false;
    }

  }

?>